## s3d 0.2.1

=== CMakeLists.txt ===
project(s3d C)
set(VERSION 0.2.1)

# we require cmake 2.4.4 or higher
cmake_minimum_required(VERSION 2.4.7)

# set cmake policies
if(COMMAND cmake_policy)
	cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

# Add directory with library checks to search path
list(APPEND CMAKE_MODULE_PATH "${s3d_SOURCE_DIR}/cmake/modules")

# set path to objects
set(OBJECTPATH "${CMAKE_INSTALL_PREFIX}/share/s3d/objs")
STRING(TOUPPER "${CMAKE_BUILD_TYPE}" BUILD_TYPE)
if (NOT BUILD_TYPE MATCHES "REL(WITHDEBINFO|EASE)")
	set(OBJECTPATH "${OBJECTPATH}:${s3d_SOURCE_DIR}/objs")
endif (NOT BUILD_TYPE MATCHES "REL(WITHDEBINFO|EASE)")

# set debug level with -DDEBUG=level
include(SetDebugLevel)

# Enable profiling support with -DPROFILING
include(EnableProfiling)

# Set some compiler flags
include(SetCCWarnFlags)

# Enable C9X if possible
# disabled because s3d uses c9x features but doesnt compile with it
#include(SetC9X)

# Run configure stuff
include(ConfigureChecks.cmake)

add_subdirectory(libs3d)
add_subdirectory(libs3dw)
add_subdirectory(apps)
add_subdirectory(cmake)
add_subdirectory(Documentation)
add_subdirectory(example)
add_subdirectory(objs)
add_subdirectory(server)

file(GLOB INCLUDE_EXPERIMENTAL experimental)
if (INCLUDE_EXPERIMENTAL)
	add_subdirectory(experimental)
endif (INCLUDE_EXPERIMENTAL)

# Generate s3drc
configure_file(s3drc.cmake ${s3d_BINARY_DIR}/s3drc)
install(PROGRAMS ${s3d_BINARY_DIR}/s3drc DESTINATION /etc)

=== Documentation/CMakeLists.txt ===
add_subdirectory(libs3d)
add_subdirectory(libs3dw)
add_subdirectory(manpages)
add_subdirectory(server)

project(Documentation C)

if (DOCBOOK2HTML_COMPILER)
	add_custom_command(
		OUTPUT  ${Documentation_BINARY_DIR}/doc_output/index.html
		COMMAND ${DOCBOOK2HTML_COMPILER}
		ARGS    ${Documentation_SOURCE_DIR}/s3d.docbook -o ${Documentation_BINARY_DIR}/doc_output
		DEPENDS ${Documentation_SOURCE_DIR}/s3d.docbook
			${Documentation_SOURCE_DIR}/bookinfo.docbook
			${Documentation_SOURCE_DIR}/server/server.docbook
			${Documentation_SOURCE_DIR}/libs3dw/libs3dw.docbook
			${Documentation_SOURCE_DIR}/libs3d/libs3d.docbook
		COMMENT "Build s3d documentation"
	)

	add_custom_target(documentation ALL echo
		DEPENDS   ${Documentation_BINARY_DIR}/doc_output/index.html
	)

	# install
	set(DOC_DIR ${CMAKE_INSTALL_PREFIX}/share/doc/s3d)
	install(CODE "file(GLOB DOCS ${Documentation_BINARY_DIR}/doc_output/*)\n foreach(file \${DOCS}) \n file(INSTALL DESTINATION ${DOC_DIR} TYPE FILE FILES \"\${file}\") \n endforeach (file \"\${DOCS}\")")
else (DOCBOOK2HTML_COMPILER)
	PkgStatus_Later("docbook2html (pkg name: docbook-utils)")

	# print late status
	Collected_PkgStatus("documentation")
endif (DOCBOOK2HTML_COMPILER)

=== example/CMakeLists.txt ===
# add option for enabling/disabling profiling
option(EXAMPLES "Enable/disable compilation of examples" ON)

if (EXAMPLES)
	include_directories(${s3d_SOURCE_DIR}/libs3d ${s3d_SOURCE_DIR}/libs3dw)

	add_executable(filebrowser filebrowser.c)
	target_link_libraries(filebrowser ${S3D_LIBRARIES} ${MATH_LIBRARIES})

	add_executable(hudtest hudtest.c)
	target_link_libraries(hudtest ${S3D_LIBRARIES} ${MATH_LIBRARIES})

	add_executable(katze katze.c)
	target_link_libraries(katze ${S3D_LIBRARIES} ${MATH_LIBRARIES})

	add_executable(linetest linetest.c)
	target_link_libraries(linetest ${S3D_LIBRARIES} ${MATH_LIBRARIES})

	add_executable(modelloader modelloader.c)
	target_link_libraries(modelloader ${S3D_LIBRARIES} ${MATH_LIBRARIES})

	add_executable(nichtsnutz nichtsnutz.c)
	target_link_libraries(nichtsnutz ${S3D_LIBRARIES} ${MATH_LIBRARIES})

	add_executable(ptrtest ptrtest.c)
	target_link_libraries(ptrtest ${S3D_LIBRARIES} ${MATH_LIBRARIES})

	add_executable(radius_test radius_test.c)
	target_link_libraries(radius_test ${S3D_LIBRARIES} ${MATH_LIBRARIES})

	add_executable(s3dclock s3dclock.c)
	target_link_libraries(s3dclock ${S3D_LIBRARIES} ${MATH_LIBRARIES})

	add_executable(snowman snowman.c)
	target_link_libraries(snowman ${S3D_LIBRARIES} ${MATH_LIBRARIES})

	add_executable(strtest strtest.c)
	target_link_libraries(strtest ${S3D_LIBRARIES} ${MATH_LIBRARIES})

	add_executable(texturetest texturetest.c)
	target_link_libraries(texturetest ${S3D_LIBRARIES} ${MATH_LIBRARIES})

	add_executable(widgets widgets.c)
	target_link_libraries(widgets ${S3D_LIBRARIES} ${S3DW_LIBRARIES} ${MATH_LIBRARIES})

	add_executable(wiresphere wiresphere.c)
	target_link_libraries(wiresphere ${S3D_LIBRARIES} ${MATH_LIBRARIES})
endif (EXAMPLES)

=== libs3d/CMakeLists.txt ===
include_directories(${s3d_SOURCE_DIR}/server)

set(S3D_LIBRARY_DEPENDENCIES  ${MATH_LIBRARIES} ${G3D_LIBRARIES} ${FONTCONFIG_LIBRARIES} ${FREETYPE_LIBRARIES})

add_library(s3d SHARED callback.c error.c event.c fontselect.c freetype.c
	io.c modelread.c network.c object_queue.c proto_in.c proto_out.c
	sei_construct.c sei_misc.c sei_monotone.c sei_tri.c shm.c
	shm_ringbuf.c tcp.c vector.c hash.c texture.c)
target_link_libraries(s3d ${S3D_LIBRARY_DEPENDENCIES})
set_target_properties(s3d PROPERTIES VERSION ${VERSION} SOVERSION 2)
set(S3D_LIBRARIES ${S3D_LIBRARY_DEPENDENCIES} s3d CACHE PATHS "Path to libraries")

# install
install(TARGETS s3d
	LIBRARY DESTINATION lib
	ARCHIVE DESTINATION lib
)

install(FILES s3d.h s3d_keysym.h DESTINATION include/)

#pkg config
configure_file(libs3d.pc.cmake ${s3d_BINARY_DIR}/libs3d/libs3d.pc @ONLY)
install(FILES ${s3d_BINARY_DIR}/libs3d/libs3d.pc DESTINATION lib/pkgconfig/)

=== libs3dw/CMakeLists.txt ===
include_directories(${s3d_SOURCE_DIR}/libs3d ${s3d_SOURCE_DIR}/libs3dw)

set(S3DW_LIBRARY_DEPENDENCIES s3d ${S3D_LIBRARY_DEPENDENCIES})

add_library(s3dw SHARED animate.c arrange.c button.c event.c input.c
	label.c root.c scrollbar.c style.c surface.c textbox.c widget.c)
target_link_libraries(s3dw ${S3DW_LIBRARY_DEPENDENCIES})
set_target_properties(s3dw PROPERTIES VERSION ${VERSION} SOVERSION 2)
set(S3DW_LIBRARIES s3dw CACHE PATHS "Path to libraries")

# install
install(TARGETS s3dw
	LIBRARY DESTINATION lib
	ARCHIVE DESTINATION lib
)

install(FILES s3dw.h DESTINATION include/)

#pkg config
configure_file(libs3dw.pc.cmake ${s3d_BINARY_DIR}/libs3dw/libs3dw.pc @ONLY)
install(FILES ${s3d_BINARY_DIR}/libs3dw/libs3dw.pc DESTINATION lib/pkgconfig/)

=== server/CMakeLists.txt ===
include_directories(${s3d_SOURCE_DIR}/libs3d)

# base files
set(server_src allocate.c cull.c error.c event.c graphics.c
	main.c matrix.c mcp.c navigation.c network.c object.c
	process.c proto.c shm.c	shm_ringbuf.c tcp.c user.c)

# files for sdl support
set(server_sdl_src graphics_sdl.c user_sdl.c)

# add sdl files and libs
if (SDL_FOUND)
	list(APPEND server_src ${server_sdl_src})
	list(APPEND server_libs ${SDL_LIBRARY})
endif (SDL_FOUND)

# compile base files + sdl specific parts
add_executable(server ${server_src})

target_link_libraries(server ${OPENGL_LIBRARY} ${MATH_LIBRARIES} ${server_libs})
set_target_properties(server PROPERTIES OUTPUT_NAME "s3d")

# install
install(TARGETS server RUNTIME DESTINATION bin)

=== apps/dot_mcp/CMakeLists.txt ===
project(dot_mcp C)

include_directories(${s3d_SOURCE_DIR}/libs3d)

add_executable(dot_mcp main.c menu.c)
target_link_libraries(dot_mcp ${S3D_LIBRARIES} ${MATH_LIBRARIES})

# install
install(TARGETS dot_mcp RUNTIME DESTINATION bin)

=== apps/kism3d/CMakeLists.txt ===
project(kism3d C)

if (PTHREADS_FOUND)
	include_directories(${s3d_SOURCE_DIR}/libs3d ${s3d_SOURCE_DIR}/libs3dw)

	add_executable(kism3d client.c gui.c kism3d.c network.c)
	target_link_libraries(kism3d ${S3D_LIBRARIES} ${S3DW_LIBRARIES}
		${PTHREADS_LIBRARIES} ${MATH_LIBRARIES})

	# install
	install(TARGETS kism3d RUNTIME DESTINATION bin)
else (PTHREADS_FOUND)
	PkgStatus_Later("pthreads")

	# print late status
	Collected_PkgStatus("kism3d")
endif (PTHREADS_FOUND)

=== apps/meshs3d/CMakeLists.txt ===
project(meshs3d C)

include_directories(${s3d_SOURCE_DIR}/libs3d ${s3d_SOURCE_DIR}/libs3dw)

add_executable(meshs3d hash.c main.c net.c process.c)
target_link_libraries(meshs3d ${S3D_LIBRARIES} ${S3DW_LIBRARIES}
		${MATH_LIBRARIES})

# install
install(TARGETS meshs3d RUNTIME DESTINATION bin)

=== apps/s3d_x11gate/CMakeLists.txt ===
project(s3d_x11gate C)

if (XTST_FOUND AND XTST_FOUND)
	include_directories(${s3d_SOURCE_DIR}/libs3d ${s3d_SOURCE_DIR}/libs3dw)

	add_executable(s3d_x11gate s3d_x11gate.c)
	target_link_libraries(s3d_x11gate ${S3D_LIBRARIES} ${S3DW_LIBRARIES}
		${X11_LIBRARIES} ${XTST_LIBRARIES} ${MATH_LIBRARIES})

	# install
	install(TARGETS s3d_x11gate RUNTIME DESTINATION bin)
else (XTST_FOUND AND XTST_FOUND)
	if (NOT XTST_FOUND)
		PkgStatus_Later("xtst (pkg name: libxtst-dev)")
	endif (NOT XTST_FOUND)

	if (NOT X11_FOUND)
		PkgStatus_Later("x11 (pkg name: libx11-dev)")
	endif (NOT X11_FOUND)

	# print late status
	Collected_PkgStatus("s3d_x11gate")
endif (XTST_FOUND AND XTST_FOUND)

=== apps/s3dfm/CMakeLists.txt ===
project(s3dfm C)

if (PTHREADS_FOUND)
	include_directories(${s3d_SOURCE_DIR}/libs3d ${s3d_SOURCE_DIR}/libs3dw)

	add_executable(s3dfm animation.c box.c dialog.c event.c fly.c focus.c fs.c
		icon.c main.c node.c parse.c string.c)
	target_link_libraries(s3dfm ${S3D_LIBRARIES} ${S3DW_LIBRARIES}
		${PTHREADS_LIBRARIES} ${MATH_LIBRARIES})

	# install
	install(TARGETS s3dfm RUNTIME DESTINATION bin)
else (PTHREADS_FOUND)
	PkgStatus_Later("pthreads")

	# print late status
	Collected_PkgStatus("s3dfm")
endif (PTHREADS_FOUND)

=== apps/s3dosm/CMakeLists.txt ===
project(s3dosm C)

# depends on xml2, sqlite3
if (LIBXML2_FOUND AND SQLITE3_FOUND)
	include_directories(${s3d_SOURCE_DIR}/libs3d ${s3d_SOURCE_DIR}/libs3dw)

	add_executable(s3dosm db.c draw.c gps.c http_error_codes.c http_fetcher.c#
		io.c kismet.c main.c nav.c object.c osm.c
		tag.c ui.c)

	target_link_libraries(s3dosm ${S3D_LIBRARIES} ${S3DW_LIBRARIES}
		${LIBXML2_LIBRARIES} ${SQLITE3_LIBRARIES})

	if (GPS_FOUND)
		target_link_libraries(s3dosm ${GPS_LIBRARIES})
	else (GPS_FOUND)
		PkgStatusPartial_Later("GPS support - libgps (pkg name: libgps-dev or gpsd)")
	endif (GPS_FOUND)

	Collected_PkgStatusPartial("s3dosm")
	# install
	install(TARGETS s3dosm RUNTIME DESTINATION bin)
else (LIBXML2_FOUND AND SQLITE3_FOUND)
	if (NOT LIBXML2_FOUND)
		PkgStatus_Later("libxml2 (pkg name: libxml2-dev)")
	endif (NOT LIBXML2_FOUND)

	if (NOT SQLITE3_FOUND)
		PkgStatus_Later("SQLite3 (pkg name: libsqlite3-dev)")
	endif (NOT SQLITE3_FOUND)

	# print late status
	Collected_PkgStatus("s3dosm")
endif (LIBXML2_FOUND AND SQLITE3_FOUND)

## s3d 0.2.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,8 @@
 project(s3d C)
 set(VERSION 0.2.1)
 
-# we require cmake 2.4.4 or higher
-cmake_minimum_required(VERSION 2.4.7)
+# we require cmake 2.6.3 or higher
+cmake_minimum_required(VERSION 2.6.3)
 
 # set cmake policies
 if(COMMAND cmake_policy)

=== Documentation/CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,7 @@
 	add_custom_command(
 		OUTPUT  ${Documentation_BINARY_DIR}/doc_output/index.html
 		COMMAND ${DOCBOOK2HTML_COMPILER}
-		ARGS    ${Documentation_SOURCE_DIR}/s3d.docbook -o ${Documentation_BINARY_DIR}/doc_output
+		ARGS    ${DOCBOOK2HTML_ARGS} ${Documentation_SOURCE_DIR}/s3d.docbook -o ${Documentation_BINARY_DIR}/doc_output
 		DEPENDS ${Documentation_SOURCE_DIR}/s3d.docbook
 			${Documentation_SOURCE_DIR}/bookinfo.docbook
 			${Documentation_SOURCE_DIR}/server/server.docbook
@@ -26,7 +26,7 @@
 	set(DOC_DIR ${CMAKE_INSTALL_PREFIX}/share/doc/s3d)
 	install(CODE "file(GLOB DOCS ${Documentation_BINARY_DIR}/doc_output/*)\n foreach(file \${DOCS}) \n file(INSTALL DESTINATION ${DOC_DIR} TYPE FILE FILES \"\${file}\") \n endforeach (file \"\${DOCS}\")")
 else (DOCBOOK2HTML_COMPILER)
-	PkgStatus_Later("docbook2html (pkg name: docbook-utils)")
+	PkgStatus_Later("xmlto (pkg name: xmlto)")
 
 	# print late status
 	Collected_PkgStatus("documentation")

=== example/CMakeLists.txt ===
# add option for enabling/disabling profiling
option(EXAMPLES "Enable/disable compilation of examples" ON)

if (EXAMPLES)
	include_directories(${s3d_SOURCE_DIR}/libs3d ${s3d_SOURCE_DIR}/libs3dw)

	add_executable(filebrowser filebrowser.c)
	target_link_libraries(filebrowser s3d ${MATH_LIBRARIES})

	add_executable(hudtest hudtest.c)
	target_link_libraries(hudtest s3d ${MATH_LIBRARIES})

	add_executable(katze katze.c)
	target_link_libraries(katze s3d ${MATH_LIBRARIES})

	add_executable(linetest linetest.c)
	target_link_libraries(linetest s3d ${MATH_LIBRARIES})

	add_executable(modelloader modelloader.c)
	target_link_libraries(modelloader s3d ${MATH_LIBRARIES})

	add_executable(nichtsnutz nichtsnutz.c)
	target_link_libraries(nichtsnutz s3d ${MATH_LIBRARIES})

	add_executable(ptrtest ptrtest.c)
	target_link_libraries(ptrtest s3d ${MATH_LIBRARIES})

	add_executable(radius_test radius_test.c)
	target_link_libraries(radius_test s3d ${MATH_LIBRARIES})

	add_executable(s3dclock s3dclock.c)
	target_link_libraries(s3dclock s3d ${MATH_LIBRARIES})

	add_executable(snowman snowman.c)
	target_link_libraries(snowman s3d ${MATH_LIBRARIES})

	add_executable(strtest strtest.c)
	target_link_libraries(strtest s3d ${MATH_LIBRARIES})

	add_executable(texturetest texturetest.c)
	target_link_libraries(texturetest s3d ${MATH_LIBRARIES})

	add_executable(widgets widgets.c)
	target_link_libraries(widgets s3d s3dw ${MATH_LIBRARIES})

	add_executable(wiresphere wiresphere.c)
	target_link_libraries(wiresphere s3d ${MATH_LIBRARIES})
endif (EXAMPLES)

=== libs3d/CMakeLists.txt ===
include_directories(${s3d_SOURCE_DIR}/server)

set(S3D_LIBRARY_DEPENDENCIES  ${MATH_LIBRARIES} ${G3D_LIBRARIES} ${FONTCONFIG_LIBRARIES} ${FREETYPE_LIBRARIES})

add_library(s3d SHARED callback.c endian.c error.c event.c fontselect.c
	freetype.c io.c modelread.c network.c object_queue.c proto_in.c
	proto_out.c sei_construct.c sei_misc.c sei_monotone.c sei_tri.c shm.c
	shm_ringbuf.c tcp.c vector.c hash.c texture.c)
target_link_libraries(s3d ${S3D_LIBRARY_DEPENDENCIES})
set_target_properties(s3d PROPERTIES VERSION ${VERSION} SOVERSION 2
                      LINK_INTERFACE_LIBRARIES "")

# install
install(TARGETS s3d
	RUNTIME DESTINATION bin
	LIBRARY DESTINATION lib
	ARCHIVE DESTINATION lib
)

install(FILES s3d.h s3d_keysym.h DESTINATION include/)

#pkg config
configure_file(libs3d.pc.cmake ${s3d_BINARY_DIR}/libs3d/libs3d.pc @ONLY)
install(FILES ${s3d_BINARY_DIR}/libs3d/libs3d.pc DESTINATION lib/pkgconfig/)

=== libs3dw/CMakeLists.txt ===
include_directories(${s3d_SOURCE_DIR}/libs3d ${s3d_SOURCE_DIR}/libs3dw)

set(S3DW_LIBRARY_DEPENDENCIES s3d ${MATH_LIBRARIES})

add_library(s3dw SHARED animate.c arrange.c button.c event.c input.c
	label.c root.c scrollbar.c style.c surface.c textbox.c widget.c)
target_link_libraries(s3dw ${S3DW_LIBRARY_DEPENDENCIES})
set_target_properties(s3dw PROPERTIES VERSION ${VERSION} SOVERSION 2
                      LINK_INTERFACE_LIBRARIES "")

# install
install(TARGETS s3dw
	RUNTIME DESTINATION bin
	LIBRARY DESTINATION lib
	ARCHIVE DESTINATION lib
)

install(FILES s3dw.h DESTINATION include/)

#pkg config
configure_file(libs3dw.pc.cmake ${s3d_BINARY_DIR}/libs3dw/libs3dw.pc @ONLY)
install(FILES ${s3d_BINARY_DIR}/libs3dw/libs3dw.pc DESTINATION lib/pkgconfig/)

=== objs/CMakeLists.txt ===
set(s3d-objs abs2.3ds abs.3ds accesspoint.3ds accesspoint_inet.3ds arrow2.3ds
	arrow.3ds AUTHORS big_p.3ds bigsphere.3ds btn_close.3ds btn_maximize.3ds
	btn_minimize.3ds btn_rotate.3ds clock_bg.3ds comp.3ds cube.3ds cubey.3ds
	cubeyholes.3ds dot.3ds dotdot.3ds duno.3ds film.3ds folder.3ds
	geometry.3ds go_button.3ds internet.3ds katze_body.3ds katze_leg.3ds
	katze_tail.3ds lil_p.3ds materials.3ds meshnode.3ds miu.3ds
	new_sphere.3ds notes.3ds reset.3ds ringsystem.3ds rotate.3ds
	s3d_berlios_de.3ds s3dstart.3ds sec_p.3ds snow_body.3ds snow_foot.3ds
	snow_head.3ds sphere.3ds spikeybla.3ds star.3ds weirdball.3ds
	wtf.3ds xyz.3ds)

# install
install(FILES ${s3d-objs} DESTINATION share/s3d/objs)

=== server/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 include_directories(${s3d_SOURCE_DIR}/libs3d)
 
 # base files
-set(server_src allocate.c cull.c error.c event.c graphics.c
+set(server_src allocate.c cull.c endian.c error.c event.c graphics.c
 	main.c matrix.c mcp.c navigation.c network.c object.c
 	process.c proto.c shm.c	shm_ringbuf.c tcp.c user.c)
 
@@ -17,7 +17,7 @@
 # compile base files + sdl specific parts
 add_executable(server ${server_src})
 
-target_link_libraries(server ${OPENGL_LIBRARY} ${MATH_LIBRARIES} ${server_libs})
+target_link_libraries(server ${OPENGL_gl_LIBRARY} ${MATH_LIBRARIES} ${server_libs})
 set_target_properties(server PROPERTIES OUTPUT_NAME "s3d")
 
 # install

=== Documentation/manpages/CMakeLists.txt ===
install(FILES "dot_mcp.1" DESTINATION share/man/man1)
install(FILES "kism3d.1" DESTINATION share/man/man1)
install(FILES "meshs3d.1" DESTINATION share/man/man1)
install(FILES "s3dfm.1" DESTINATION share/man/man1)
install(FILES "s3d.1" DESTINATION share/man/man1)
install(FILES "s3dosm.1" DESTINATION share/man/man1)
install(FILES "s3dvt.1" DESTINATION share/man/man1)
install(FILES "s3d_x11gate.1" DESTINATION share/man/man1)

=== apps/dot_mcp/CMakeLists.txt ===
project(dot_mcp C)

include_directories(${s3d_SOURCE_DIR}/libs3d)

add_executable(dot_mcp main.c menu.c)
target_link_libraries(dot_mcp s3d ${MATH_LIBRARIES})

# install
install(TARGETS dot_mcp RUNTIME DESTINATION bin)

=== apps/kism3d/CMakeLists.txt ===
--- 
+++ 
@@ -4,8 +4,8 @@
 	include_directories(${s3d_SOURCE_DIR}/libs3d ${s3d_SOURCE_DIR}/libs3dw)
 
 	add_executable(kism3d client.c gui.c kism3d.c network.c)
-	target_link_libraries(kism3d ${S3D_LIBRARIES} ${S3DW_LIBRARIES}
-		${PTHREADS_LIBRARIES} ${MATH_LIBRARIES})
+	target_link_libraries(kism3d s3d s3dw ${PTHREADS_LIBRARIES}
+	                      ${MATH_LIBRARIES})
 
 	# install
 	install(TARGETS kism3d RUNTIME DESTINATION bin)

=== apps/meshs3d/CMakeLists.txt ===
project(meshs3d C)

include_directories(${s3d_SOURCE_DIR}/libs3d ${s3d_SOURCE_DIR}/libs3dw)

add_executable(meshs3d hash.c main.c net.c process.c)
target_link_libraries(meshs3d s3d s3dw ${MATH_LIBRARIES})

# install
install(TARGETS meshs3d RUNTIME DESTINATION bin)

=== apps/s3d_x11gate/CMakeLists.txt ===
--- 
+++ 
@@ -4,8 +4,8 @@
 	include_directories(${s3d_SOURCE_DIR}/libs3d ${s3d_SOURCE_DIR}/libs3dw)
 
 	add_executable(s3d_x11gate s3d_x11gate.c)
-	target_link_libraries(s3d_x11gate ${S3D_LIBRARIES} ${S3DW_LIBRARIES}
-		${X11_LIBRARIES} ${XTST_LIBRARIES} ${MATH_LIBRARIES})
+	target_link_libraries(s3d_x11gate s3d s3dw ${X11_LIBRARIES}
+	                      ${XTST_LIBRARIES} ${MATH_LIBRARIES})
 
 	# install
 	install(TARGETS s3d_x11gate RUNTIME DESTINATION bin)

=== debian/changelog ===
s3d (0.2.1.1-5) unstable; urgency=low

  * Correct spelling errors found by lintian
  * debian/copyright: Update copyright years
  * Upgraded to policy 3.8.4, no changes required
  * debian/rules:
    - Enable parallel builds using dh's --parallel
    - Inform about missing installed files using dh's --list-missing
  * debian/patches:
    - Add s3dfm_overflow.patch, Fix potential buffer overflow when parsing
      directory
    - Add libs3d_small-infinity.patch, Don't accidently use INFINITY from math.h
    - Add s3dvt_glibc-pty.patch, Reimplement PTY/TTY mode using glibc

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Fri, 14 May 2010 11:46:52 +0200

s3d (0.2.1.1-4) unstable; urgency=low

  * Register HTML documentation in doc-base
  * debian/patches:
    - Add libgps_2_90.patch, Fix FTBFS with libgps-2.90 (Closes: #560077)

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Tue, 08 Dec 2009 21:34:58 +0100

s3d (0.2.1.1-3) unstable; urgency=low

  * Remove unused libraries added by pkg-config from libs3d and libs3dw
  * Convert to 3.0 (quilt) source format
  * debian/control:
    - Remove shlibs:Depends for binary packages without shared libs dependencies
    - Remove unneeded build dependency to quilt
    - Remove cdbs and change debhelper dependency to 7 for for dh support
  * Rewrote debian/rules with dh

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Mon, 16 Nov 2009 01:32:25 +0100

s3d (0.2.1.1-2) unstable; urgency=low

  * Upgraded to policy 3.8.3, no changes required
  * Add README.source with information about patch management
  * debian/patches:
    - Change to dep3 patch tagging guidelines
    - Remove number before patches as order is given by debian/patches/series
    - Add version_number.patch, Correct version number for soname and pkg-config
  * Remove Martin Stern from debian/copyright as his files were removed

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Thu, 15 Oct 2009 18:39:02 +0200

s3d (0.2.1.1-1) unstable; urgency=low

  * New upstream release
  * debian/control:
    - Reduce debhelper dependency to 5
    - Only depend on xmlto and docbook-xml in Build-Depends-Indep for
      arch all package s3d-doc
  * debian/patches:
    - Add 100-installable-examples.patch, make example usable without
      extra headers
    - Remove upstream merged patches 100-hyphen-used-as-minus-sign.patch,
      101-fix-sigbus-on-mips.patch, 102-send-correct-load-over-net.patch,
      103-endian-safe-float.patch, 104-reduce-depends.patch,
      105-s3dfm-pathnames.patch, 106-g3dorientation.patch,
      107-fix-cmake-ftbfs.patch, 108-fix-gpsd-ftbfs.patch,
      109-strip-libs3d-parameters.patch, 110-s3dosm-api06.patch,
      111-xmlto-documentation.patch
  * Install examples with libs3d-dev and libs3dw-dev
  * Convert debian/copyright to new dep5 version
  * Upgraded to policy 3.8.2, no changes required
  * Install upstream changelogs

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Sat, 11 Jul 2009 17:00:52 +0200

s3d (0.2.1-14) unstable; urgency=low

  * Add function and structure manpages for libs3d2 and libs3dw
  * debian/patches:
    - Add 111-xmlto-documentation.patch, workaround for LP: #372243 by
      using xmlto instead of docbook-utils for documentation generation
  * debian/control:
    - Depend on xmlto as new tool to generate the html documentation
    - Update Depend on >=docbook-xml-4.5 for DocBook 4.5 DTDs

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Mon, 11 May 2009 23:05:11 +0200

s3d (0.2.1-13) unstable; urgency=low

  * debian/patches:
    - Add 109-strip-libs3d-parameters.patch, remove only libs3d options from
      program arguments without looking at the order of occurrence
    - Add 110-s3dosm-api06.patch, use API version 0.6 of Openstreetmaps.org
  * debian/control:
    - Depend on docbook-xml to disable DTD lookup by docbook2html on
      www.oasis-open.org (Closes LP: #368537)
    - Allow Debian Maintainers to upload new versions of s3d

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Tue, 28 Apr 2009 13:43:34 +0200

s3d (0.2.1-12) unstable; urgency=low

  * debian/patches/:
    - Update 104-reduce-depends.patch to apply without warnings
    - Add 108-fix-gpsd-ftbfs.patch to fix ftbfs with libgps-dev 2.39
      (Closes: #524088)

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Tue, 14 Apr 2009 23:04:41 +0200

s3d (0.2.1-11) unstable; urgency=low

  * debian/rules: Don't install TODO file with every package

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Wed, 18 Mar 2009 14:14:38 +0100

s3d (0.2.1-10) unstable; urgency=low

  * Rewrote debian/rules using cdbs
  * Move s3d-dbg to new section debug
  * Upgraded to policy 3.8.1, no changes required
  * Add 107-fix-cmake-ftbfs.patch to fix FTBFS with cmake 2.6.3
    (Closes: #520163)

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Tue, 17 Mar 2009 22:24:56 +0100

s3d (0.2.1-9) unstable; urgency=low

  * debian/rules: Use CFLAGS and LDFLAGS from dpkg-buildpackage
  * Update debian/watch to find .tar.gz
  * debian/control:
    - Correct short description of libs3dw2
    - Only depend on at least one binary package for s3d-dbg
  * Add 106-g3dorientation.patch, correct model orientation with libg3d-0.0.7
  * Update copyright years in debian/copyright

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Sun, 15 Feb 2009 13:29:04 +0100

s3d (0.2.1-8) unstable; urgency=low

  * Move VCS-Git repository to berlios in debian/control
  * Workaround for GCC bug with disappearing minimized dot_mcp programs in
    patches/103-endian-safe-float.patch
  * Add patch 105-s3dfm-pathnames to correct detection of filetypes in subpaths
    in s3dfm
  * Replace deprecated dh_clean -k with dh_prep in debian/rules

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Wed, 24 Dec 2008 20:58:35 +0100

s3d (0.2.1-7) unstable; urgency=low

  * Replace s3d@packages.debian.org maintainer with first Uploader in
    debian/control

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Thu, 11 Dec 2008 21:58:44 +0100

s3d (0.2.1-6) unstable; urgency=low



=== debian/control ===
Source: s3d
Section: net
Priority: extra
Maintainer: Simon Wunderlich <siwu@hrz.tu-chemnitz.de>
Uploaders: Sven Eckelmann <sven.eckelmann@gmx.de>
Dm-Upload-Allowed: yes
Homepage: http://s3d.berlios.de/
Standards-Version: 3.8.4
Vcs-Browser: https://git.berlios.de/cgi-bin/gitweb.cgi?p=s3d
Vcs-Git: git://git.berlios.de/s3d
Build-Depends: debhelper (>= 7.4.10), cmake (>= 2.6.3), libfreetype6-dev,
 libfontconfig-dev, libglib2.0-dev, libg3d-dev (>= 0.0.7), libsdl-dev,
 libgl1-mesa-dev | libgl-dev, libxml2-dev, libsqlite3-dev, libxtst-dev,
 libgps-dev (>= 2.90)
Build-Depends-Indep: xmlto, docbook-xml (>= 4.5)

Package: s3d
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: dotmcp (= ${binary:Version})
Description: 3d network display server
 s3d is a 3d network display server which can be used as 3d desktop environment.
 .
 This package provides the display server.

Package: s3d-dbg
Section: debug
Architecture: any
Depends: ${misc:Depends},
 libs3d2 (= ${binary:Version}) | libs3dw2 (= ${binary:Version}) |
 s3d (= ${binary:Version}) | s3dvt (= ${binary:Version}) |
 s3dfm (= ${binary:Version}) | dotmcp (= ${binary:Version}) |
 s3dx11gate (= ${binary:Version}) | meshs3d (= ${binary:Version}) |
 s3dosm (= ${binary:Version}) | kism3d (= ${binary:Version})
Description: 3d network display server (debug files)
 s3d is a 3d network display server which can be used as 3d desktop environment.
 .
 This package contains the debug files.

Package: libs3d2
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: 3d network display server library
 s3d is a 3d network display server which can be used as 3d desktop environment.
 .
 This package provides the library for communication with the display server.

Package: libs3d-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libs3d2 (= ${binary:Version})
Recommends: s3d-doc (= ${source:Version})
Description: 3d network display server library - development files
 s3d is a 3d network display server which can be used as 3d desktop environment.
 .
 This package provides the header files for building your own s3d programs.

Package: libs3dw2
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: 3d network display server widget library
 s3d is a 3d network display server which can be used as 3d desktop environment.
 .
 This package provides the widget library.

Package: libs3dw-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libs3dw2 (= ${binary:Version})
Recommends: s3d-doc (= ${source:Version})
Description: 3d network display server widget library - development files
 s3d is a 3d network display server which can be used as 3d desktop environment.
 .
 This package provides the header files for using widgets in your s3d programs.

Package: s3d-data
Architecture: all
Depends: ${misc:Depends}
Description: 3d network display server data files
 s3d is a 3d network display server which can be used as 3d desktop environment.
 .
 This package contains arch-independent files.

Package: s3d-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Documentation for s3d
 s3d is a 3d network display server which can be used as 3d desktop environment.
 .
 This package provides documentation for s3d.

Package: dotmcp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, s3d-data (= ${source:Version}),
 libg3d-plugins
Recommends: s3dvt (= ${binary:Version}), meshs3d (= ${binary:Version}),
 s3dx11gate (= ${binary:Version}), s3dfm (= ${binary:Version})
Description: mcp for s3d
 s3d is a 3d network display server which can be used as 3d desktop environment.
 .
 This package provides a mcp for s3d.

Package: kism3d
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, s3d-data (= ${source:Version}),
 libg3d-plugins
Description: 802.11 visualizer for s3d
 s3d is a 3d network display server which can be used as 3d desktop environment.
 .
 This package provides a 802.11 visualizer for s3d.

Package: meshs3d
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, s3d-data (= ${source:Version}),
 libg3d-plugins
Description: OLSR/B.A.T.M.A.N. topology visualizer for s3d
 s3d is a 3d network display server which can be used as 3d desktop environment.
 .
 This package provides a OLSR/B.A.T.M.A.N. topology visualizer for s3d.

Package: s3dfm
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: s3d file manager
 s3d is a 3d network display server which can be used as 3d desktop environment.
 .
 This package provides a file manager for s3d.

Package: s3dosm
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, s3d-data (= ${source:Version}),
 libg3d-plugins
Description: gps card application for s3d
 s3d is a 3d network display server which can be used as 3d desktop environment.
 .
 This package provides a gps card application for s3d.

Package: s3dvt
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, bash (>= 2.0)
Description: 3d terminal emulator for s3d
 s3d is a 3d network display server which can be used as 3d desktop environment.
 .
 This package provides a 3d terminal emulator for s3d.

Package: s3dx11gate
Section: x11
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: 3d gateway for x11 desktops
 s3d is a 3d network display server which can be used as 3d desktop environment.
 .
 This package provides a 3d gateway for x11 desktops.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

CMAKE_EXTRA_FLAGS := -DBUILD_EXPERIMENTAL:BOOL=OFF
CMAKE_EXTRA_FLAGS += -DENABLE_FINAL:BOOL=ON
CMAKE_EXTRA_FLAGS += -DCMAKE_EXE_LINKER_FLAGS:STRING="$(LDFLAGS) -Wl,--as-needed"
CMAKE_EXTRA_FLAGS += -DCMAKE_SHARED_LINKER_FLAGS:STRING="$(LDFLAGS) -Wl,--as-needed"

%:
	dh $@ --parallel --list-missing

get-orig-source:
	uscan --verbose --force-download

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

override_dh_strip:
	dh_strip -a --dbg-package=s3d-dbg

override_dh_installdocs:
	dh_installdocs -A README Documentation/RelNotes*

.PHONY: get-orig-source
